'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ErrorFloatingContainer = function (_React$Component) {
	_inherits(ErrorFloatingContainer, _React$Component);

	function ErrorFloatingContainer() {
		_classCallCheck(this, ErrorFloatingContainer);

		var _this = _possibleConstructorReturn(this, (ErrorFloatingContainer.__proto__ || Object.getPrototypeOf(ErrorFloatingContainer)).call(this));

		_this.state = { isFloating: false };
		_this.reposition = _this.reposition.bind(_this);
		return _this;
	}

	_createClass(ErrorFloatingContainer, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {

			return this.state.isFloating !== nextState.isFloating;
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			// In the case that the docked message is not visible,
			// this repositions the error message to the top of the screen immediately
			setTimeout(function () {
				_this2.reposition();
			}, 0);
			window.addEventListener('scroll', this.reposition);
			window.addEventListener('resize', this.reposition);
		}
	}, {
		key: 'componentWillUnMount',
		value: function componentWillUnMount() {

			window.removeEventListener('scroll', this.reposition);
			window.addEventListener('resize', this.reposition);
		}
	}, {
		key: 'reposition',
		value: function reposition() {

			var containerRect = this.refs.container.getBoundingClientRect();
			this.refs.placeHolderTop.style.height = containerRect.height + 'px';
			var placeHolderRect = this.refs.placeHolderTop.getBoundingClientRect();
			var updateWithRect = void 0;

			if (this.state.isFloating) {
				updateWithRect = placeHolderRect;
			} else {
				updateWithRect = containerRect;
			}

			var containerTop = updateWithRect.top;
			var nextFloatingState = void 0;

			if (containerTop <= 0) {
				// Top of the container is out of the view, so the container needs to be floated
				nextFloatingState = true;
				this.refs.placeHolderTop.style.display = 'block';
				this.refs.innerContainer.style.left = '0px';
			} else {
				// Top of the container is in the view, so the container should be docked
				nextFloatingState = false;
				this.refs.placeHolderTop.style.display = 'none';
				this.refs.innerContainer.style.left = updateWithRect.left + 'px';
			}

			this.setState({ isFloating: nextFloatingState });
		}
	}, {
		key: 'render',
		value: function render() {

			var containerClassName = (0, _classnames2.default)({
				'error-floating-container': true,
				'floating': this.state.isFloating
			});

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ ref: 'container', className: containerClassName },
					_react2.default.createElement(
						'div',
						{ ref: 'innerContainer', className: 'inner-container' },
						this.props.children
					)
				),
				_react2.default.createElement('div', { ref: 'placeHolderTop' })
			);
		}
	}]);

	return ErrorFloatingContainer;
}(_react2.default.Component);

exports.default = ErrorFloatingContainer;